﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

#pragma hide=1

Static StrConstant k_fullpackageFolder = "root:Packages:imgT"
Static StrConstant k_fullpanel = "imgT_display#imgT_panel"
Static StrConstant k_imgDisplay = "imgT_display"

Function disp_Tab3Draw(pwidth,pheight,ptabpos)
	variable pwidth, pheight, ptabpos

	variable tvoffset = ptabpos+30
	
	TabControl tab_main, value=3, userdata(ptab)="3"
	
	TitleBox layout_tab3,pos={12,tvoffset},size={84,22},title="Image Layout"
	TitleBox layout_tab3,fSize=16,frame=0,fStyle=1,disable=1
	
	Button buttonRedoColor_tab3, pos={pwidth-60,tvoffset},size={40,25},title="Redo"
	Button buttonRedoColor_tab3,proc=X_ButtonProc,disable=1
	
	tvoffset += 25
	
	CheckBox checkShowAxes_tab3, pos={20,tvoffset},size={20,20},title="Axes"
	CheckBox checkShowAxes_tab3 value=1,proc=X_CheckProc,disable=1
	
	PopupMenu popupScaleBar_tab3, pos={80,tvoffset-2},size={80,20},title="Scale Bar"
	PopupMenu popupScaleBar_tab3, mode=1, value="None;LT;RT;RB;LB;", proc=X_PopMenuProc, disable=1

	PopupMenu popupSBColor_tab3, pos={210,tvoffset-2}, title="Color", disable=1
	PopupMenu popupSBColor_tab3, value="*COLORPOP*",proc=X_PopMenuProc,popColor=(0,0,0)
	
	tvoffset += 30
	
	TitleBox cprint_tab3,pos={12,tvoffset},size={84,22},title="Contact Print"
	TitleBox cprint_tab3,fSize=16,frame=0,fStyle=1, disable=1
	
	ValDisplay valdispccp_tab3, pos={210,tvoffset+4}, title="contact prints"
	ValDisplay valdispccp_tab3 size={100,20},value=_NUM:0, disable=1
	
	Button buttonClearAll_tab3, pos={pwidth - 90,tvoffset},size={80,22},title="Clear List"
	Button buttonClearAll_tab3, proc=X_ButtonProc,disable=1
	
	tvoffset += 25
	
	CheckBox checkCP_tab3,pos={20,tvoffset},size={20,20},title="include"
	CheckBox checkCP_tab3,value=0,proc=X_CheckProc,disable=1
	
	SetVariable setvarCPNote_tab3,pos={120,tvoffset},title="Notes",size={280,20}
	SetVariable setvarCPNote_tab3,value=_STR:"",disable=1

	tvoffset += 25
	
	Button buttonDoCPrint_tab3, pos={pwidth-140,tvoffset},size={130,25},title="Make Contact Layout"
	Button buttonDoCPrint_tab3,proc=X_ButtonProc,disable=1

	return 0

end

Function disp_UpdateTab3()

	CheckBox checkCP_tab3, win=$k_fullpanel, value=f_IsContactPrint()
	ValDisplay valdispccp_tab3, win=$k_fullpanel, value=_NUM:f_CountofContactPrints()
	if (f_CountofContactPrints()>0)
		Button buttonDoCPrint_tab3, win=$k_fullpanel, disable=0
		Button buttonClearAll_tab3, win=$k_fullpanel, disable=0
	else
		Button buttonDoCPrint_tab3, win=$k_fullpanel, disable=2
		Button buttonClearAll_tab3, win=$k_fullpanel, disable=2
	endif
	return 0
end

// remove a contact print recreaction string
Function T3_ClearAllContactPrintImages()

	// global values
	if (!DataFolderExists(k_fullpackageFolder + ":contactprint"))
		return 0
	endif
	
	DFREF cpf = $k_fullpackageFolder + ":contactprint"
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	variable ic, npts
	string wStr
	
	npts = CountObjectsDFR(cpf,3)
	
	for (ic=0;ic<npts;ic+=1)
		wStr = GetIndexedObjNameDFR(cpf,3,ic)
		KillWindow/Z $wStr
	endfor
	
	KillDataFolder/Z cpf
	DFREF cdf = GetDataFolderDFR()
	SetDataFolder pf
	NewDataFolder/O contactprint
	SetDataFolder cdf

	Checkbox checkCP_tab3, win=$k_fullpanel, value=0
	ValDisplay valdispccp_tab3, win=$k_fullpanel, value = 0
	
	Button buttonDoCPrint_tab3, win=$k_fullpanel, disable=2
	Button buttonClearAll_tab3, win=$k_fullpanel, disable=2
	
	SetVariable setvarCPNote_tab3, win=$k_fullpanel, disable=2
	return 0
end

// remove a contact print recreaction string
Function T3_RemoveContactPrint()

	// global values
	DFREF cpf = $k_fullpackageFolder + ":contactprint"
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	string cpstr
	cpstr = cwdfolder[5,inf] + "_" + cwfile
	if (f_IsStack())
		sprintf cpstr "%s_%d", cpstr, f_PlaneNumber()
	endif

	DFREF cdf = GetDataFolderDFR()
	SetDataFolder cpf
	killstrings/Z $cpstr
	killwindow/Z $cpstr
	
	SetDataFolder cdf

	return 0
end

// store as contact print recreaction
Function T3_StoreasContactPrint([sfolder,sfile])
	string sfolder, sfile

	// global values
	DFREF cpf = $k_fullpackageFolder + ":contactprint"
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	DFREF cdf = GetDataFolderDFR()
	
	string eistr, wname
	
	if (ParamIsDefault(sfolder))
		sfolder = cwdfolder[5,inf]
	endif
	if (ParamIsDefault(sfile))
		sfile = cwfile
	endif

	wname = "root:" + cwdfolder + ":" + cwfile
	
	string cpstrng, cprec, scprec
	string rgex = "((?s)(.)+)\\tNewPanel/HOST=#"
	string pstr, sstr
	
	SetDataFolder pf
	NewDataFolder/O/S contactprint
	
	cpstrng = sfolder + "_" + sfile
	if (f_isStack())
		cpstrng += "_" + num2str(f_PlaneNumber())
	endif
	
	cprec = WinRecreation(k_imgDisplay,0)
	eistr = note($wname)

	SplitString/E=(rgex) cprec, scprec
	
	sstr = "\tModifyGraph expand=0.5,lsize=1"
	sstr += "\r\tTextBox/C/N=name/F=0/A=LT \"\\Z08" + cpstrng + "\""
	if (strlen(eistr)!=0)
		sstr += "\rTextBox/C/N=ImgInfo/F=0/A=RB/X=0/Y=0 " + "\"\\Z08" + eistr +  "\""
	endif
	sstr += "\rEndMacro"
	scprec += sstr
	
	string/G $cpstrng = scprec
	
	SetDataFolder cdf
	
	return 0
end

// update current image as contact print
Function T3_UpdateContactPrint()

	if (f_IsContactPrint()==0)
		Checkbox checkCP_tab3, win=$k_fullpanel, value=0
	else
		T3_StoreasContactPrint()
		Checkbox checkCP_tab3, win=$k_fullpanel, value=1
	endif
	
	ValDisplay valdispccp_tab3 win=$k_fullpanel, value=_NUM:f_CountofContactPrints()
	
	return 0
	
	if (f_CountofContactPrints() == 0)
		Button buttonDoCPrint_tab3, win=$k_fullpanel, disable=2
		Button buttonClearAll_tab3, win=$k_fullpanel, disable=2
		SetVariable setvarCPNote_tab3, win=$k_fullpanel, disable=2
	else
		Button buttonDoCPrint_tab3, win=$k_fullpanel, disable=0
		Button buttonClearAll_tab3, win=$k_fullpanel, disable=0
		SetVariable setvarCPNote_tab3, win=$k_fullpanel, disable=0
	endif
	
	return 0

end

// turn on/off axes
Function disp_ShowAxes(onoff)
	variable onoff
	
	switch(onoff)
		case 0:		// off
			ModifyGraph nticks(top)=0, nticks(left)=0
			break
		case 1:
			ModifyGraph nticks(top)=12, nticks(left)=12
			break
	endswitch
	return 0
end

// set scale bar
Function disp_ShowScaleBar(how)
	variable how
	
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile	
	wave/SDFR=pf scalewx, scalewy, scaledx
	
	variable iscale, ix, iy, ipx, ipy, idx, idy, sp, mpp, scdw
	variable idxoffset=0, idyoffset=0, idwidth, idheight
	string tstr = "\\Z24\\K(65535,65534,49151)"

	// kill tag
	if (how == 0)
		Tag/K/N=sctag/W=$k_imgdisplay
		ModifyGraph/W=$k_imgdisplay/Z hidetrace(scalewy)=1
		scalewy = NaN
		scalewx = NaN
		return 0
	endif
	
	// get image scale settings
	iscale = f_ImageSize()[0]	// how scaled (none, pixel, width, height)
	ipx = f_ImageSize()[1]		// image width (pixels)
	ipy = f_ImageSize()[2]		// image height (pixels)
	ix = f_ImageSize()[3]			// image width (meters)
	iy = f_ImageSize()[4]			// image height (meters)
	mpp = f_ImageSize()[5]		// meters per pixel
	
	// marker wave position is in graph coordinates!
	// get axis scaling to set offsets
	GetAxis/W=$k_imgDisplay/Q left
	idxoffset = min(v_max,v_min)	
	idheight = abs(v_max - v_min)
	GetAxis/W=$k_imgDisplay/Q top
	idyoffset = min(v_max,v_min)
	idwidth = abs(v_max - v_min)
	
	// use 10% of image width and height
	// round to even factors of 10
	sp = floor(log(idwidth)) - 1
	idx = 10^sp
	sp = floor(log(idheight)) - 1
	idy = 10^sp
	
	// determine best settings
	switch(iscale)
		case 0:		// no scale (pixels)
			scaledx = idx/2
			sprintf tstr, "%s%d pixels", tstr, idx
			break
		default:		// scale in meters
			// length of pixel scale bar
			scdw = idx*mpp
			sp = floor(log(scdw))
			sp += round(scdw/10^(sp+1))
			scaledx = 10^sp/(2)
			scdw = 1
			//print "values: ", mpp, idx, scaledx[0], sp, scdw, mpp
			if (scaledx[0] < idx*0.4)
				scaledx = 10^(sp+1)/(2*mpp)
				//sp -= 1
				scdw = 10
				idx *= 2
			endif
			switch(sp)
				case -9:
					sprintf tstr, "%s%1.0f nm", tstr, scdw
					break
				case -6:
					sprintf tstr, "%s%1.0f um", tstr, scdw
					break
				case -3:
					sprintf tstr, "%s%1.0f mm", tstr, scdw
					break
				case -2:
					sprintf tstr, "%s%1.0f cm", tstr, scdw //10^(sp+2)
					break
				case 0:
					sprintf tstr, "%s%1.0f m", tstr, scdw
					break
				case 3:
					sprintf tstr, "%s%1.0f km", tstr, scdw
					break
				default:
					sprintf tstr, "%s%3.4f m", tstr, scdw
					break
			endswitch
			break
	endswitch
	
	switch(how)
		case 1:		// on LT
			scalewx = idxoffset + 2.5*idx
			scalewy = idyoffset + 1.5*idy
			//ModifyGraph/W=$k_imgdisplay/Z hidetrace(scalewy)=0
			break
		case 2:		// on RT
			scalewx = (idxoffset +idwidth) - 2.5*idx
			scalewy = idyoffset + 1.5*idy
			//ModifyGraph/W=$k_imgdisplay/Z hidetrace(scalewy)=0
			break
		case 3:		// on RB
			scalewx = (idxoffset + idwidth) - 2.5*idx
			scalewy = (idyoffset + idheight) - 1*idy
			//ModifyGraph/W=$k_imgdisplay/Z hidetrace(scalewy)=0
			break
		case 4:		// on LB
			scalewx = idxoffset + 2.5*idx
			scalewy = (idyoffset + idheight) - 1*idy
			//ModifyGraph/W=$k_imgdisplay/Z hidetrace(scalewy)=0
			break
	endswitch
	ModifyGraph/W=$k_imgdisplay/Z hidetrace(scalewy)=0
	Tag/C/N=sctag/F=0/A=MB/L=0/B=1/X=0/Y=1/W=$k_imgdisplay scalewy, 0,tstr

	return 0
end

// change scale bar color
Function disp_SetScaleBarColor(cstr)
	string cstr

	string tstr, estr = "(.+)(\\K.+\))(.+)", zstr, kstr,fstr

	tstr = AnnotationInfo(k_imgDisplay,"sctag",0)
	if (numtype(strlen(tstr)) == 2)
		return -1
	endif
	tstr = StringFromList(ItemsInList(tstr)-1,tstr)
	SplitString/E=estr tstr[5,inf], zstr,kstr,fstr
	
	tstr = "\Z24\K" + cstr + fstr
	
	Tag/C/N=sctag/W=$k_imgDisplay tstr
	
	ControlInfo/W=$k_fullpanel popupSBColor_tab3
	ModifyGraph/W=$k_imgDisplay rgb(scalewy)=(V_red,V_green,V_blue)
	
	
	return 0	
end

// ***
// Contact Prints

// generate contact print layout
Function T3_CreateContactPrintLayout()

	// global values
	DFREF cpf = $k_fullpackageFolder + ":contactprint"
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	variable cntp, ic, ip, pc, wsize
	string strName,fulllist="",porl,tilestr,eistr
	
	cntp = f_CountofContactPrints()
	
	if (cntp<=0)
		DoAlert/T="Contact Print", 0, "No images stored as contact prints."
		return 0
	endif

	if (cntp < 3)
		wsize = 8*72/cntp
		porl = "LANDSCAPE"
		tilestr = "Tile/A=(0,2)"
	elseif (cntp < 5)
		wsize = 1.5*8*72/cntp
		porl = "PORTRAIT"
		tilestr = "Tile/A=(0,2)"
	elseif (cntp < 9)
		wsize = 1.5*10.5*72/cntp
		porl = "LANDSCAPE"
		tilestr = "Tile/A=(2,0)"
	elseif (cntp < 12)
		wsize = 1.5*10.5*72/cntp
		porl = "LANDSCAPE"
		tilestr = "Tile/A=(3,0)"
	else
		wsize = 10.5*72/cntp
		porl = "LANDSCAPE"
		tilestr = "Tile/A=(3,0)"
	endif
	
	for (ic=0;ic<cntp;ic+=1)
		strName = GetIndexedObjNameDFR(cpf,3,ic)
		fulllist += strName + ";"
		DoWindow/K/Z $strName
		SVAR/SDFR=cpf exCmd = $strName
		Execute/Q/Z exCmd
		DoWindow/C $strName
		ModifyGraph/W=$strname width=wsize
		DoWindow/HIDE=1 $strName
	endfor
	
	fullList = SortList(fullList)
	
	DoWindow/K/Z imgT_contactlayout
	NewLayout/P=$porl/N=imgT_contactlayout
	for (ic=0;ic<cntp;ic+=1)
		strName = StringFromList(ic,fulllist)
		AppendLayoutObject/F=0 graph $strName
	endfor
	Execute/Q/Z tilestr
	
	// add info to display
	eistr = f_DateTimeStamp() + " " + IgorInfo(1) + " " + IgorInfo(7)
	ControlInfo/W=$k_fullpanel setvarCPNote_tab3
	if (strlen(s_value)!=0)
		eistr += "\t" + s_value
	endif
	TextBox/C/N=ExpInfo/F=0/A=RB/X=0/Y=0 eistr
	return 0
end
