﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

Static StrConstant k_fullpackageFolder = "root:Packages:imgT"
Static StrConstant k_histGraphs = "imgT_histograms"
Static StrConstant k_fullpanel = "imgT_display#imgT_panel"
Static StrConstant k_imgDisplay = "imgT_display"

// uncomment to debug
//#define DEBUG

#ifndef DEBUG
#pragma hide=1
#endif

// structure for background parameters
Static Structure S_BackgroundParams
	variable method
	variable level
	variable mask
	variable stZ
	variable oTP
	variable dofWhite
	variable doAuto
EndStructure

// function to get background parameters
Function S_GetBckgParameters(bgp)
	STRUCT S_BackgroundParams &bgp
	
	ControlInfo/W=$k_fullPanel popupThresMethod_tab2
	bgp.method = v_value-1
	ControlInfo/W=$k_fullPanel setvarThresLevel_tab2
	bgp.level = v_value
	ControlInfo/W=$k_fullPanel popupThMask_tab2
	bgp.mask = v_value - 1
	ControlInfo/W=$k_fullPanel checkMaskZero_tab2
	bgp.stZ = !v_value
	ControlInfo/W=$k_fullPanel checkAutoThreshold_tab2
	bgp.doAuto = v_value
	ControlInfo/W=$k_fullPanel popupThresOnPlane_tab2
	bgp.oTP = v_value
	ControlInfo/W=$k_fullPanel checkdofWhite_tab2
	bgp.dofWhite = v_value
	
	return 0
end

// draw tab2 - process
Function disp_Tab2Draw(pwidth,pheight, ptabpos)
	variable pwidth, pheight, ptabpos

	variable tvoffset = ptabpos + 30
	
	string qu = "\""
	string tmodes = qu + "Manual;Iterative;Bimodal;Adaptive;Fuzzy;Fuzzy+;Cluster;Otsu;" + qu
//	string pmm = qu + "None;X<[ ]>X;[> X <];"
	
	TabControl tab_main, value=2, userdata(ptab)="2"
	
	TitleBox threshold_tab2,pos={12,tvoffset},size={84,22},title="Threshold"
	TitleBox threshold_tab2,fSize=16,frame=0,fStyle=1,disable=1
	
	PopupMenu popupThresOnPlane_tab2,pos={pwidth-110,tvoffset},size={100,23},title=""
	PopupMenu popupThresOnPlane_tab2,mode=1,value="This Layer;Each Layer;All Layers;",disable=1
//		
//	Checkbox checkOTPlane_tab2,pos={pwidth-110,tvoffset},size={80,20},title="to this plane only"
//	Checkbox checkOTPlane_tab2,value=1,disable=1
	
	tvoffset += 25
	
	PopupMenu popupThresMethod_tab2,pos={20,tvoffset},size={124,25},title="Method"
	PopupMenu popupThresMethod_tab2,mode=1,popvalue="Manual",value=#tmodes, disable=1, proc=X_PopMenuProc

	SetVariable setvarThresLevel_tab2,pos={160,tvoffset},size={100,25},title="Level"
	SetVariable setvarThresLevel_tab2,limits={1,inf,1},value=_NUM:0, disable=1, proc=X_SetVarProc
	
	Checkbox checkAutoThreshold_tab2,pos={pwidth-115,tvoffset},size={25,25},title="!"
	Checkbox checkAutoThreshold_tab2,value=0,proc=X_CheckProc,disable=1
	
	Button buttonDoThreshold_tab2,pos={pwidth-85,tvoffset-5},size={75,25},proc=X_ButtonProc,title="Apply"
	Button buttonDoThreshold_tab2,disable=1
	
	tvoffset += 25
	
	PopupMenu popupThMask_tab2,pos={20,tvoffset},size={120,23},title="Mask", proc=X_PopMenuProc
	PopupMenu popupThMask_tab2,mode=1,popvalue="None;",value=f_TMasks(),disable=1
	
	Checkbox checkMaskZero_tab2,pos={150,tvoffset},size={25,25},title="@0"
	Checkbox checkMaskZero_tab2,value=1,disable=1
	
	Button buttonFillThreshold_tab2,pos={pwidth-85,tvoffset-5},size={75,25},proc=X_ButtonProc,title="Fill"
	Button buttonFillThreshold_tab2,disable=1
//	
//	Checkbox checkdofWhite_tab2,pos={200,tvoffset},size={25,25},title=""
//	Checkbox checkdofWhite_tab2,value=0,disable=1
//
//	ValDisplay valDispfwhite_tab2, pos={220,tvoffset},size={90,25}, title="f white"
//	ValDisplay valDispfwhite_tab2, value=_NUM:0,format="%3.3g", disable=1
//	
//	Button buttonShowfWhite_tab2,pos={pwidth-85,tvoffset-2},size={75,15}
//	Button buttonShowfWhite_tab2,title="Plot fWhite",disable=1,proc=X_ButtonProc

	return 0
end

// update tab
Function disp_updateTab2()
	
	DFREF pf=$k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	variable method, thlevel, tabsent=1, fwhite=0
	string thlevels = ""
	
	if (!f_ThresholdExists())
		Checkbox checkAutoThreshold_tab2, win=$k_fullPanel, disable=0, value=0
	else
		Checkbox checkAutoThreshold_tab2, win=$k_fullPanel, disable=0
	endif
	ControlInfo/W=$k_fullpanel checkAutoThreshold_tab2
	Button buttondoThreshold_tab2, win=$k_fullpanel, disable=(2*v_value)
	ControlInfo/W=$k_fullpanel popupThresMethod_tab2
	method = v_value
	switch(method)
		case 1:	// manual
			thlevel = xcsr(A,k_histGraphs)
			break
		default:	// all others
			if (f_isThreshold())
				thlevels = "root:" + cwdfolder + ":" + cwfile[4,inf] + "levels"
			else
				thlevels = "root:" + cwdfolder + ":" + cwfile[4,inf] + "_thlevels"
			endif
			wave/Z thl = $thlevels
			if (waveexists(thl))
				if (f_isStack())
					tabsent = 0
					thlevel = thl[f_PlaneNumber()][0]
					fwhite = thl[f_PlaneNumber()][1]
				else
					thlevel = thl[0][0]
					fwhite = thl[0][1]
				endif
			else
				thlevel = xcsr(A,k_histGraphs)
			endif
			if (method != 1)
				thlevels = TraceNameList(k_histGraphs,";",1)
				thlevels = StringFromList(1,SortList(thlevels))
				Cursor/W=$k_histGraphs/S=0 A, $thlevels, thlevel
			else
				thlevel = xcsr(A,k_histGraphs)
			endif
			break
	endswitch
	
	SetVariable setvarThresLevel_tab2, win=$k_fullPanel, disable=(2*(method!=1)), value=_NUM:thlevel
	if (f_IsStack())
		if (!f_StackOKtoThreshold())
			PopupMenu popupThresOnPlane_tab2, win=$k_fullPanel, value="This Layer;Each Layer;(-All Layers;",disable=0
		else
			PopupMenu popupThresOnPlane_tab2, win=$k_fullPanel, value="This Layer;Each Layer;All Layers;",disable=0
		endif
	else
		PopupMenu popupThresOnPlane_tab2, win=$k_fullPanel, disable=1
	endif
#ifdef DEBUG
	print "reset cursor due to threshold change ", thlevels, thlevel
#endif
	if (f_HasMQ())	
		ControlInfo/W=$k_fullPanel popupThMask_tab2
		PopupMenu popupThMask_tab2, win=$k_fullPanel, disable=0, value=f_TMasks(), mode=v_value
		Checkbox checkMaskZero_tab2,win=$k_fullPanel,disable=(v_value == 1)
	else
		PopupMenu popupThMask_tab2, win=$k_fullPanel, disable=0, value=f_TMasks(), mode=1
		Checkbox checkMaskZero_tab2,win=$k_fullPanel,disable=1
	endif
	return 0
end

Function T2_StartThreshold()

	STRUCT S_BackgroundParams bgp
	S_GetBckgParameters(bgp)

	variable ic, nplanes
		
	if (f_IsStack())
		switch(bgp.oTP)
			case 1:		// this plane only
				T2_DoThreshold(bgp.method,bgp.level,plane=f_PlaneNumber(),tRoI=bgp.mask,soRoI=bgp.stZ)
				break
			case 2:		// each plane
				if (bgp.method == 1)
					T2_DoThreshold(bgp.method,bgp.level,tRoI=bgp.mask,soRoI=bgp.stZ)
				else
					nplanes = f_NImagesInStack()
					for (ic=0;ic<nplanes;ic+=1)
						T2_DoThreshold(bgp.method,bgp.level,plane=ic,tRoI=bgp.mask,soRoI=bgp.stZ)
					endfor
				endif
				break
			case 3:		// all planes
				T2_DoThreshold(bgp.method,bgp.level,tRoI=bgp.mask,soRoI=bgp.stZ)
				break
		endswitch
	else
		T2_DoThreshold(bgp.method,bgp.level,tRoI=bgp.mask,soRoI=bgp.stZ)
	endif

	return 0
end

// do threshold of image
Function T2_DoThreshold(method, level, [tRoI, soRoI, plane, cfWhite])
	variable method, level, tRoI, soRoI, plane, cfWhite

	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	string wdf = "root:" + cwdfolder
	string sfile, wfile, lstr
	
	variable nimgs, thexists = 0, onpl = 0, isstack = 0
	variable npts, ic, nplanes
	
	// avoid thresholding a threshold
	// set existence of threshold
	if (f_isThreshold())
		sfile = ReplaceString("_th",cwfile,"")
		wfile = cwfile
		thexists = 1
	else
		if (f_ThresholdExists()==1)
			thexists = 1
			wfile = cwfile + "_th"
		endif
		sfile = cwfile
	endif
	lstr = sfile[4,inf] + "_thlevels"
	if (f_IsStack())
		nimgs = f_NImagesInStack()
	else
		nimgs = 1
	endif
	
	if (ParamIsDefault(tRoI))
		tRoI = 0
	endif
	if (ParamIsDefault(soRoI))
		soRoI = 1
	endif	
	if (ParamIsDefault(cfWhite))
		cfWhite = 0
	endif
	
	// work within the data folder to store threshold files
	DFREF cdf = GetDataFolderDFR()	
	SetDataFolder wdf
	
	// no prior threshold image (set) exists	
	if (!thexists)
		wfile = cwfile + "_th"
		duplicate $cwfile $wfile
		wave/SDFR=$wdf tw = $wfile
		tw = 0
		make/N=(nimgs,2)/O $lstr
		wave/SDFR=$wdf tlevels = $lstr
		tlevels = 0
	endif
	
	// set the source files (source image, threshold image, threshold level + fraction)
	wave/SDFR=$wdf simage = $sfile
	wave/SDFR=$wdf tw = $wfile
	wave/SDFR=$wdf tlevels = $lstr
	
	// assure that the threshold levels wave is the right dimensions
	if (DimSize(tlevels,1)==0)
		Redimension/N=(-1,2) tlevels
	endif
		
	if (nimgs>1)
		isstack = 1
		if (ParamIsDefault(plane))
			plane = -1
		else
			onpl = 1
		endif
	else
		plane = -1
		nimgs = 1
	endif

#ifdef DEBUG
	print "doing threshold: ", sfile, wfile, lstr, plane, level, method
#endif

	STRUCT S_MarqueeCoordinates mc
	Sf_GetMQCoordinates(mc)
	if (tRoI != 0)
		wave RoIMask = GenerateRoIMask(simage,mc,tRoI,3)
	endif
	
	switch(method)
		case 0:		//manual
			if (tRoI == 0)
				ImageThreshold/P=(plane)/M=0/T=(level)/Q simage
			else
				ImageThreshold/P=(plane)/M=0/T=(level)/Q/R={RoIMask,soRoI} simage
			endif
			v_threshold = level
			break
		case 3:		// adaptive
			if (tRoI == 0)
				ImageThreshold/P=(plane)/M=3/Q simage
			else
				ImageThreshold/P=(plane)/M=3/Q/R={RoIMask,soRoI} simage
			endif
			break
		case 1:		// iterative
		case 2:		// bimodal
		case 4:		// fuzzy
		case 5:		// fuzzy+
		case 6:		// cluster
		case 7:		// Otsu
			if (tRoI == 0)
				ImageThreshold/P=(plane)/M=(method)/Q simage
			else
				ImageThreshold/P=(plane)/M=(method)/Q/R={RoIMask,soRoI} simage
			endif
			break
	endswitch
	
	wave M_ImageThresh

	// store values
	if (isstack)
		// a stack
		if (onpl)
			tlevels[plane][0] = v_threshold
			tw[][][plane] = M_ImageThresh[p][q]
			WaveStats/Q/M=1 M_ImageThresh
			tlevels[plane][1] = V_avg/V_max
		else
			tlevels[][0] = v_threshold
			MatrixOP/O tw = M_ImageThresh
			if (cfWhite!=0)
				make/N=(nimgs)/FREE t_thlevels=0
				MultiThread t_thlevels = T2_calcLayerFrac(tw,p)
				tlevels[][1] = t_thlevels[p]/255
			endif
		endif
	else
		// not a stack
		tlevels[0][0] = v_threshold
		duplicate/O M_ImageThresh tw
		WaveStats/Q/M=1 tw
		tlevels[0][1] = V_avg/255
	endif

#ifndef DEBUG
	killwaves/Z M_ImageThresh
#endif

	SetDataFolder cdf
	
	return 0
end

// fill threshold
Function T2_FillThreshold(useMQ)
	variable useMQ

	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	string wdf = "root:" + cwdfolder
	string thfile

	if (!f_ThresholdExists())
		return 0
	endif
	
	variable isStack, cplane
	
	// set existence of threshold
	if (f_isThreshold())
		thfile = cwfile
	else
		thfile = cwfile + "_th"
	endif
	
	wave/SDFR=$wdf tsimg = $thfile
	
	if (f_isStack())
		isStack = 1
		cplane = f_PlaneNumber()
		MatrixOP/FREE tfimg = tsimg[][][cplane]
	else
		duplicate/FREE tsimg tfimg
	endif

	DFREF cdf = GetDataFolderDFR()

	NewDataFolder/O/S tmp
	
	variable a, ic = 1
	
	if (useMQ > 1)
		GetMarquee/W=$k_imgDisplay/Z left, top
		a = 0.9*abs(v_right - v_left)*abs(v_bottom - v_top)
	else
		a = 0.9*DimSize(tfimg,0)*DimSize(tfimg,1)
	endif
	
	ImageTransform/O invert tfimg
	for(ic=2;ic<10;ic+=1)
		ImageAnalyzeParticles/Q/A=(a)/FILL/M=3 stats tfimg
		if (v_numparticles == 1)
			break
		else
			a *= 1 - 0.1*ic
		endif
	endfor
	
	wave M_particle
	if (v_numparticles != 0)
		//ImageTransform/O invert M_Particle
		M_particle = M_Particle < 63 ? 255 : 0
		if (isStack)
			ImageTransform/P=(cplane)/D=M_Particle setPlane tsimg
		else
			tsimg = M_Particle
		endif
	else
		DoAlert/T="Fill Threshold", 0, "A continguous boundary was not found in the threshold. Filling was therefore unsuccessful."
	endif
	
	// kill temporary
	
	SetDataFolder cdf
	KillDataFolder/Z tmp
	
	return 0
end

// get value for layer
ThreadSafe Function T2_calcLayerFrac(ww,nl)
	wave ww
	variable nl
	
	MatrixOP/FREE val = mean(layer(ww,nl))
	return val[0]
end

// show fWhite
Function T2_showfWhite()

	KillWindow/Z fWhite
	
	DFREF pf=$k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile
	
	string thlevels
	variable npts
	
	if (f_isThreshold())
		thlevels = "root:" + cwdfolder + ":" + cwfile[4,inf] + "levels"
	else
		thlevels = "root:" + cwdfolder + ":" + cwfile[4,inf] + "_thlevels"
	endif
	wave/Z thl = $thlevels
	npts = DimSize(thl,0)
	DFREF cdf = GetDataFolderDFR()
	SetDataFolder pf
	Make/O/N=(npts)/D thfWhite
	thfWhite = thl[p][1]
	Display/N=fWhite thfWhite as "Fraction White"	
	ModifyGraph mode=3,marker=8,msize=2,mrkThick=1,rgb=(0,0,0)
	SetAxis/N=1 left 0,*
	SetDataFolder cdf
	
	return 0
end

Function T2_ShowThreshold()

	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwfile
	
	cwfile += "_th"
	
	disp_ShowAnImage()

	return 0
end